{{
  Test Fast Walsh Hadamard Transform

  Jonathan "lonesock" Dummer
}}

' set for the standard 5MHz crystal...this must be correct for the serial code to work
CON
  _CLKMODE = XTAL1 + PLL16X 
  _XINFREQ = 5_000_000

OBJ
  term          : "FullDuplexSerial"
  fwht          : "FWHT"

CON
  buf_size      = |<7          ' must be a power of 2
VAR
  long  buf[buf_size]
  
PUB test_FWHT | i, prng, sw

  ' init my objects
  term.start( 31, 30, 0, 115_200 )
  waitcnt( (clkfreq >> 2) + cnt )
  fwht.start

  ' random stuff in the buffer
  prng := pi
  repeat i from 0 to buf_size-1
    buf[i] := ( (?prng) & constant( |<16-1 ) ) - |<15

  ' time it (stopwatch)
  sw := -cnt
  fwht.FWHT( @buf, buf_size )
  sw += cnt

  repeat 1
    term.str( string( "Transforming a buffer of length " ) )
    term.dec( buf_size )
    term.str( string( " took " ) )
    term.dec( sw )
    term.str( string( " counts.", 13 ) )

    'waitcnt( (clkfreq << 2) + cnt )

  ' show the swizzle order
  {
  repeat i from 0 to 31
    term.dec( i )
    term.str( string( " => " ) )
    term.dec( ((i >>1) ^ i) >< 5 )
    term.tx( 13 )
  '}